﻿<AML>
 <Item type="Method" id="4633C0FFF06F4101923A36BDEF645B9F" action="add">
  <comments>2018-01-05 - MyoThet</comments>
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[/* *****************************************************************************
Created By/Company:		Chan 
Creation Date:			2019-02-01
Description:
    Read Excel File and set value to form property.
Hooks:
	Type:	Form    :   sop_commercial_invoice
	Event:	button1 ( onClick )
	
Revisions:
	Rev Date		Modified By			Description
	2018-01-05      MyoThet         Add 'sop_select_file' property for File Upload instead of top.aras.vault.SelectFile() method
	2019-02-01		Chan		    set Method Template and update to get returning data from javascript method.
	2019-02-01      Chan            Calculate total amount of stock item with discount and without discount.
***************************************************************************** */
//debugger;
var item = document.thisItem;
var myInnovator = item.getInnovator();

/** Add 'sop_select_file' property for File Upload instead of top.aras.vault.SelectFile() method **/
var sop_select_file = item.getProperty("sop_select_file", "");
var select_file_item = document.thisItem.getItemsByXPath("//Item[@type='File']");

if (select_file_item) {

    var file_count = select_file_item.getItemCount();
    var selected_file = select_file_item.getItemByIndex(file_count - 1);
    var CheckIn = selected_file.apply();
    if (CheckIn.isError()) {
        top.aras.AlertError("Error in File Item CheckIn.");
        return false;
    }
}

var file_id = CheckIn.getProperty("id");
var fileName = CheckIn.getProperty("filename", "");

if (fileName === undefined || fileName === '') {
    alert("You must be choose File(xlsx).");
    return;
}
var allowedExtensions = /(\.xlsx|\.xls)$/i;
if (!allowedExtensions.exec(fileName)) {
    alert('Please upload file having extensions .xlsx/.xls only.');
    return;
}


var gst_percent = item.getProperty("pop_gst_percent");
var gst_percent_decimal = parseFloat(gst_percent) / 100;

var fileItem = myInnovator.newItem("File", "add");

var result = null;
var params = "<file_id>" + file_id + "</file_id>";
result = myInnovator.applyMethod("SOP_Import_CI_Excel_Data", params);

if (result === null || result.isError()) {
    top.aras.AlertError(result.getErrorDetail());
    top.aras.AlertError("Error in Reading Excel File.");
    return;
}

var method_result = result.getResult();
if (method_result.indexOf("ExceptionMessage") !== -1) {
    top.aras.AlertError(method_result);
    return false;
}

var result_count = result.getItemCount();
if (result_count > 0) {
    var result_detail = result.getRelationships("sop_commercial_invoice_details");
    for (var i = 0; i < result_detail.getItemCount(); i++) {
        var excelData = result_detail.getItemByIndex(i);

        var CIDetail = myInnovator.newItem("sop_commercial_invoice_details", "add");
        var stk_code = excelData.getProperty("stk_code");
        var stk_location = excelData.getProperty("stk_location");
        var stk_uom = excelData.getProperty("stk_uom");
        if (stk_code !== undefined) {
            var stock = myInnovator.getItemById("stk_stock_setup", stk_code);
            CIDetail.setPropertyItem("stk_code", stock);
        }
        if (stk_location !== undefined) {
            var location_item = myInnovator.getItemById("stk_location", stk_location);
            CIDetail.setPropertyItem("stk_location", location_item);
        }
        if (stk_uom !== undefined) {
            var uom = myInnovator.getItemById("stk_uom", stk_uom);
            CIDetail.setPropertyItem("stk_uom", uom);
        }
        CIDetail.setProperty("stk_part_number", excelData.getProperty("stk_part_number", "")); //2018-01-16--MyoThet
        CIDetail.setProperty("stk_qty", excelData.getProperty("stk_qty"));
        CIDetail.setProperty("stk_description", excelData.getProperty("stk_description"));
        CIDetail.setProperty("stk_price", excelData.getProperty("stk_price"));
        CIDetail.setProperty("stk_total_amount", excelData.getProperty("stk_total_amount"));
        CIDetail.setProperty("sop_po_item", excelData.getProperty("sop_po_item"));
        CIDetail.setProperty("sop_box_no", excelData.getProperty("sop_box_no"));
        CIDetail.setProperty("sop_serial_no", excelData.getProperty("sop_serial_no"));
        CIDetail.setProperty("source_id", document.thisItem.getProperty("id"));
        document.thisItem.addRelationship(CIDetail);
        document.thisItem.setAttribute("isDirty", "1");

    }
} else {
    top.aras.AlertError("There is no data return from reading excel file.");
    return;
}

myHandleItemChange("sop_sale_order", result.getProperty("sop_sale_order", ""));
myHandleItemChange("sop_packing_list_no", result.getProperty("sop_packing_list_no", ""));
myHandleItemChange("sop_invoice_no", result.getProperty("sop_invoice_no", ""));
myHandleItemChange("acc_project", result.getProperty("acc_project", ""));
myHandleItemChange("sop_country_of_origin", result.getProperty("sop_country_of_origin", ""));
myHandleItemChange("sop_incoterm", result.getProperty("sop_incoterm", ""));
myHandleItemChange("sop_brand", result.getProperty("sop_brand", ""));
myHandleItemChange("sop_invoice_date", result.getProperty("sop_invoice_date", ""));
myHandleItemChange("sop_customer", result.getProperty("sop_customer", ""));
myHandleItemChange("sop_customer_address", result.getProperty("sop_customer_address", ""));
myHandleItemChange("sop_customer_phone", result.getProperty("sop_customer_phone", ""));
myHandleItemChange("sop_invoice_to_contact", result.getProperty("sop_invoice_to_contact", ""));
myHandleItemChange("sop_ship_to", result.getProperty("sop_ship_to", ""));
myHandleItemChange("sop_ship_to_address", result.getProperty("sop_ship_to_address", ""));
myHandleItemChange("sop_po_reference", result.getProperty("sop_po_reference", ""));
myHandleItemChange("pop_sub_amount", result.getProperty("pop_sub_amount", "0.00"));
myHandleItemChange("pop_lumpsum_discount", result.getProperty("pop_lumpsum_discount", "0.00"));

/*Calculate Total Amount with discount or without discount*/
var SubAmount = result.getProperty("pop_sub_amount", "")
SubAmount = parseFloat(SubAmount);
var sub_total = 0;
var gst_amount = 0;
var total_amount = 0;
var total_currency_amount = 0;
var deduct_discount_sub_total = 0;
var poi_discount = result.getProperty("pop_lumpsum_discount", "0.00");
var _discount = parseFloat(poi_discount);
myHandleItemChange("pop_hide_sub_total", SubAmount.toFixed(2));
deduct_discount_sub_total = SubAmount - _discount;
myHandleItemChange("pop_sub_amount", deduct_discount_sub_total.toFixed(2));
gst_amount = (deduct_discount_sub_total * gst_percent_decimal);
myHandleItemChange("pop_gst_amount", gst_amount.toFixed(2));
total_amount = (deduct_discount_sub_total + gst_amount);
myHandleItemChange("pop_total_amount", total_amount.toFixed(2));

/*Calculate Total Amount with discount or without discount*/

//Refresh Relationship
var tabbar = parent.relationships.relTabbar;
var tabID = tabbar.GetTabId("CI Details");
parent.relationships.iframesCollection[tabID].contentWindow.doSearch(1);

function myHandleItemChange(property, value) {
    if (top.instance.document) {
        
        top.instance.handleItemChange(property, value);
    } else {
        
        top.frames[1].handleItemChange(property, value);
    }
}]]></method_code>
  <method_type>JavaScript</method_type>
  <name>sop_ci_new_excelfile_import</name>
 </Item>
</AML>